diff --git a/src/include/catalog/dependency.h b/src/include/catalog/dependency.h
index d027075a4c..076fe7ff28 100644
--- a/src/include/catalog/dependency.h
+++ b/src/include/catalog/dependency.h
@@ -220,7 +220,7 @@ extern List *getAutoExtensionsOfObject(Oid classId, Oid objectId);
 
 extern bool sequenceIsOwned(Oid seqId, char deptype, Oid *tableId, int32 *colId);
 extern List *getOwnedSequences(Oid relid);
-extern Oid	getIdentitySequence(Oid relid, AttrNumber attnum, bool missing_ok);
+extern Oid	getIdentitySequence(Oid relid, AttrNumber attphysnum, bool missing_ok);
 
 extern Oid	get_index_constraint(Oid indexId);
 
diff --git a/src/include/catalog/heap.h b/src/include/catalog/heap.h
index 07c5b88f0e..69d226dfd6 100644
--- a/src/include/catalog/heap.h
+++ b/src/include/catalog/heap.h
@@ -26,7 +26,7 @@
 
 typedef struct RawColumnDefault
 {
-	AttrNumber	attnum;			/* attribute to attach default to */
+	AttrNumber	attphysnum;			/* attribute to attach default to */
 	Node	   *raw_default;	/* default value (untransformed parse tree) */
 	bool		missingMode;	/* true if part of add column processing */
 	char		generated;		/* attgenerated setting */
@@ -37,7 +37,7 @@ typedef struct CookedConstraint
 	ConstrType	contype;		/* CONSTR_DEFAULT or CONSTR_CHECK */
 	Oid			conoid;			/* constr OID if created, otherwise Invalid */
 	char	   *name;			/* name, or NULL if none */
-	AttrNumber	attnum;			/* which attr (only for DEFAULT) */
+	AttrNumber	attphysnum;			/* which attr (only for DEFAULT) */
 	Node	   *expr;			/* transformed default or check expr */
 	bool		skip_validation;	/* skip validation? (only for CHECK) */
 	bool		is_local;		/* constraint has local (non-inherited) def */
@@ -127,10 +127,10 @@ extern Node *cookDefault(ParseState *pstate,
 extern void DeleteRelationTuple(Oid relid);
 extern void DeleteAttributeTuples(Oid relid);
 extern void DeleteSystemAttributeTuples(Oid relid);
-extern void RemoveAttributeById(Oid relid, AttrNumber attnum);
+extern void RemoveAttributeById(Oid relid, AttrNumber attphysnum);
 
 extern void CopyStatistics(Oid fromrelid, Oid torelid);
-extern void RemoveStatistics(Oid relid, AttrNumber attnum);
+extern void RemoveStatistics(Oid relid, AttrNumber attphysnum);
 
 extern const FormData_pg_attribute *SystemAttributeDefinition(AttrNumber attno);
 
diff --git a/src/include/catalog/pg_attrdef.h b/src/include/catalog/pg_attrdef.h
index a21dd3812b..53373c4d63 100644
--- a/src/include/catalog/pg_attrdef.h
+++ b/src/include/catalog/pg_attrdef.h
@@ -33,7 +33,7 @@ CATALOG(pg_attrdef,2604,AttrDefaultRelationId)
 
 	Oid			adrelid BKI_LOOKUP(pg_class);	/* OID of table containing
 												 * attribute */
-	int16		adnum;			/* attnum of attribute */
+	int16		adnum;			/* attphysnum of attribute */
 
 #ifdef CATALOG_VARLEN			/* variable-length fields start here */
 	pg_node_tree adbin BKI_FORCE_NOT_NULL;	/* nodeToString representation of
@@ -53,18 +53,18 @@ DECLARE_TOAST(pg_attrdef, 2830, 2831);
 DECLARE_UNIQUE_INDEX(pg_attrdef_adrelid_adnum_index, 2656, AttrDefaultIndexId, on pg_attrdef using btree(adrelid oid_ops, adnum int2_ops));
 DECLARE_UNIQUE_INDEX_PKEY(pg_attrdef_oid_index, 2657, AttrDefaultOidIndexId, on pg_attrdef using btree(oid oid_ops));
 
-DECLARE_FOREIGN_KEY((adrelid, adnum), pg_attribute, (attrelid, attnum));
+DECLARE_FOREIGN_KEY((adrelid, adnum), pg_attribute, (attrelid, attphysnum));
 
 
-extern Oid	StoreAttrDefault(Relation rel, AttrNumber attnum,
+extern Oid	StoreAttrDefault(Relation rel, AttrNumber attphysnum,
 							 Node *expr, bool is_internal,
 							 bool add_column_mode);
-extern void RemoveAttrDefault(Oid relid, AttrNumber attnum,
+extern void RemoveAttrDefault(Oid relid, AttrNumber attphysnum,
 							  DropBehavior behavior,
 							  bool complain, bool internal);
 extern void RemoveAttrDefaultById(Oid attrdefId);
 
-extern Oid	GetAttrDefaultOid(Oid relid, AttrNumber attnum);
+extern Oid	GetAttrDefaultOid(Oid relid, AttrNumber attphysnum);
 extern ObjectAddress GetAttrDefaultColumnAddress(Oid attrdefoid);
 
 #endif							/* PG_ATTRDEF_H */
diff --git a/src/include/catalog/pg_attribute.h b/src/include/catalog/pg_attribute.h
index 053294c99f..746566eb8d 100644
--- a/src/include/catalog/pg_attribute.h
+++ b/src/include/catalog/pg_attribute.h
@@ -68,7 +68,7 @@ CATALOG(pg_attribute,1249,AttributeRelationId) BKI_BOOTSTRAP BKI_ROWTYPE_OID(75,
 	int16		attlen;
 
 	/*
-	 * attnum is the "attribute number" for the attribute:	A value that
+	 * attphysnum is the "attribute number" for the attribute:	A value that
 	 * uniquely identifies this attribute within its class. For user
 	 * attributes, Attribute numbers are greater than 0 and not greater than
 	 * the number of attributes in the class. I.e. if the Class pg_class says
@@ -78,9 +78,9 @@ CATALOG(pg_attribute,1249,AttributeRelationId) BKI_BOOTSTRAP BKI_ROWTYPE_OID(75,
 	 * System attributes have attribute numbers less than 0 that are unique
 	 * within the class, but not constrained to any particular range.
 	 *
-	 * Note that (attnum - 1) is often used as the index to an array.
+	 * Note that (attphysnum - 1) is often used as the index to an array.
 	 */
-	int16		attnum;
+	int16		attphysnum;
 
 	/*
 	 * attndims is the declared number of dimensions, if an array type,
@@ -207,7 +207,7 @@ CATALOG(pg_attribute,1249,AttributeRelationId) BKI_BOOTSTRAP BKI_ROWTYPE_OID(75,
 typedef FormData_pg_attribute *Form_pg_attribute;
 
 DECLARE_UNIQUE_INDEX(pg_attribute_relid_attnam_index, 2658, AttributeRelidNameIndexId, on pg_attribute using btree(attrelid oid_ops, attname name_ops));
-DECLARE_UNIQUE_INDEX_PKEY(pg_attribute_relid_attnum_index, 2659, AttributeRelidNumIndexId, on pg_attribute using btree(attrelid oid_ops, attnum int2_ops));
+DECLARE_UNIQUE_INDEX_PKEY(pg_attribute_relid_attphysnum_index, 2659, AttributeRelidPhysNumIndexId, on pg_attribute using btree(attrelid oid_ops, attphysnum int2_ops));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/catalog/pg_constraint.h b/src/include/catalog/pg_constraint.h
index e7d967f137..39c5c23095 100644
--- a/src/include/catalog/pg_constraint.h
+++ b/src/include/catalog/pg_constraint.h
@@ -173,8 +173,8 @@ DECLARE_UNIQUE_INDEX_PKEY(pg_constraint_oid_index, 2667, ConstraintOidIndexId, o
 DECLARE_INDEX(pg_constraint_conparentid_index, 2579, ConstraintParentIndexId, on pg_constraint using btree(conparentid oid_ops));
 
 /* conkey can contain zero (InvalidAttrNumber) if a whole-row Var is used */
-DECLARE_ARRAY_FOREIGN_KEY_OPT((conrelid, conkey), pg_attribute, (attrelid, attnum));
-DECLARE_ARRAY_FOREIGN_KEY((confrelid, confkey), pg_attribute, (attrelid, attnum));
+DECLARE_ARRAY_FOREIGN_KEY_OPT((conrelid, conkey), pg_attribute, (attrelid, attphysnum));
+DECLARE_ARRAY_FOREIGN_KEY((confrelid, confkey), pg_attribute, (attrelid, attphysnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/catalog/pg_index.h b/src/include/catalog/pg_index.h
index f853846ee1..13d4fcb805 100644
--- a/src/include/catalog/pg_index.h
+++ b/src/include/catalog/pg_index.h
@@ -73,7 +73,7 @@ DECLARE_INDEX(pg_index_indrelid_index, 2678, IndexIndrelidIndexId, on pg_index u
 DECLARE_UNIQUE_INDEX_PKEY(pg_index_indexrelid_index, 2679, IndexRelidIndexId, on pg_index using btree(indexrelid oid_ops));
 
 /* indkey can contain zero (InvalidAttrNumber) to represent expressions */
-DECLARE_ARRAY_FOREIGN_KEY_OPT((indrelid, indkey), pg_attribute, (attrelid, attnum));
+DECLARE_ARRAY_FOREIGN_KEY_OPT((indrelid, indkey), pg_attribute, (attrelid, attphysnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/catalog/pg_partitioned_table.h b/src/include/catalog/pg_partitioned_table.h
index 9b78f84cd5..c6da704bf4 100644
--- a/src/include/catalog/pg_partitioned_table.h
+++ b/src/include/catalog/pg_partitioned_table.h
@@ -69,6 +69,6 @@ DECLARE_TOAST(pg_partitioned_table, 4165, 4166);
 DECLARE_UNIQUE_INDEX_PKEY(pg_partitioned_table_partrelid_index, 3351, PartitionedRelidIndexId, on pg_partitioned_table using btree(partrelid oid_ops));
 
 /* partattrs can contain zero (InvalidAttrNumber) to represent expressions */
-DECLARE_ARRAY_FOREIGN_KEY_OPT((partrelid, partattrs), pg_attribute, (attrelid, attnum));
+DECLARE_ARRAY_FOREIGN_KEY_OPT((partrelid, partattrs), pg_attribute, (attrelid, attphysnum));
 
 #endif							/* PG_PARTITIONED_TABLE_H */
diff --git a/src/include/catalog/pg_statistic.h b/src/include/catalog/pg_statistic.h
index cdf7448139..d63b8dd30f 100644
--- a/src/include/catalog/pg_statistic.h
+++ b/src/include/catalog/pg_statistic.h
@@ -138,7 +138,7 @@ DECLARE_TOAST(pg_statistic, 2840, 2841);
 
 DECLARE_UNIQUE_INDEX_PKEY(pg_statistic_relid_att_inh_index, 2696, StatisticRelidAttnumInhIndexId, on pg_statistic using btree(starelid oid_ops, staattnum int2_ops, stainherit bool_ops));
 
-DECLARE_FOREIGN_KEY((starelid, staattnum), pg_attribute, (attrelid, attnum));
+DECLARE_FOREIGN_KEY((starelid, staattnum), pg_attribute, (attrelid, attphysnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/catalog/pg_statistic_ext.h b/src/include/catalog/pg_statistic_ext.h
index b8520ba923..96b260e34d 100644
--- a/src/include/catalog/pg_statistic_ext.h
+++ b/src/include/catalog/pg_statistic_ext.h
@@ -74,7 +74,7 @@ DECLARE_UNIQUE_INDEX_PKEY(pg_statistic_ext_oid_index, 3380, StatisticExtOidIndex
 DECLARE_UNIQUE_INDEX(pg_statistic_ext_name_index, 3997, StatisticExtNameIndexId, on pg_statistic_ext using btree(stxname name_ops, stxnamespace oid_ops));
 DECLARE_INDEX(pg_statistic_ext_relid_index, 3379, StatisticExtRelidIndexId, on pg_statistic_ext using btree(stxrelid oid_ops));
 
-DECLARE_ARRAY_FOREIGN_KEY((stxrelid, stxkeys), pg_attribute, (attrelid, attnum));
+DECLARE_ARRAY_FOREIGN_KEY((stxrelid, stxkeys), pg_attribute, (attrelid, attphysnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/catalog/pg_trigger.h b/src/include/catalog/pg_trigger.h
index 194277bca5..7036916879 100644
--- a/src/include/catalog/pg_trigger.h
+++ b/src/include/catalog/pg_trigger.h
@@ -85,7 +85,7 @@ DECLARE_INDEX(pg_trigger_tgconstraint_index, 2699, TriggerConstraintIndexId, on
 DECLARE_UNIQUE_INDEX(pg_trigger_tgrelid_tgname_index, 2701, TriggerRelidNameIndexId, on pg_trigger using btree(tgrelid oid_ops, tgname name_ops));
 DECLARE_UNIQUE_INDEX_PKEY(pg_trigger_oid_index, 2702, TriggerOidIndexId, on pg_trigger using btree(oid oid_ops));
 
-DECLARE_ARRAY_FOREIGN_KEY((tgrelid, tgattr), pg_attribute, (attrelid, attnum));
+DECLARE_ARRAY_FOREIGN_KEY((tgrelid, tgattr), pg_attribute, (attrelid, attphysnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
 
diff --git a/src/include/executor/execExpr.h b/src/include/executor/execExpr.h
index e34db8c93c..709b84bd79 100644
--- a/src/include/executor/execExpr.h
+++ b/src/include/executor/execExpr.h
@@ -301,9 +301,9 @@ typedef struct ExprEvalStep
 		/* for EEOP_INNER/OUTER/SCAN_[SYS]VAR[_FIRST] */
 		struct
 		{
-			/* attnum is attr number - 1 for regular VAR ... */
+			/* attphysnum is attr number - 1 for regular VAR ... */
 			/* but it's just the normal (negative) attr number for SYSVAR */
-			int			attnum;
+			int			attphysnum;
 			Oid			vartype;	/* type OID of variable */
 		}			var;
 
@@ -323,7 +323,7 @@ typedef struct ExprEvalStep
 			/* target index in ExprState->resultslot->tts_values/nulls */
 			int			resultnum;
 			/* source attribute number - 1 */
-			int			attnum;
+			int			attphysnum;
 		}			assign_var;
 
 		/* for EEOP_ASSIGN_TMP[_MAKE_RO] */
diff --git a/src/include/executor/spi.h b/src/include/executor/spi.h
index b2c0c7486c..a49ea6cfef 100644
--- a/src/include/executor/spi.h
+++ b/src/include/executor/spi.h
@@ -161,7 +161,7 @@ extern CachedPlan *SPI_plan_get_cached_plan(SPIPlanPtr plan);
 extern HeapTuple SPI_copytuple(HeapTuple tuple);
 extern HeapTupleHeader SPI_returntuple(HeapTuple tuple, TupleDesc tupdesc);
 extern HeapTuple SPI_modifytuple(Relation rel, HeapTuple tuple, int natts,
-								 int *attnum, Datum *Values, const char *Nulls);
+								 int *attphysnum, Datum *Values, const char *Nulls);
 extern int	SPI_fnumber(TupleDesc tupdesc, const char *fname);
 extern char *SPI_fname(TupleDesc tupdesc, int fnumber);
 extern char *SPI_getvalue(HeapTuple tuple, TupleDesc tupdesc, int fnumber);
diff --git a/src/include/executor/tuptable.h b/src/include/executor/tuptable.h
index 6306bb6fc6..3b8f0607a0 100644
--- a/src/include/executor/tuptable.h
+++ b/src/include/executor/tuptable.h
@@ -165,7 +165,7 @@ struct TupleTableSlotOps
 	 * to false, if it's not NULL. Throws an error if the slot type does not
 	 * support system attributes.
 	 */
-	Datum		(*getsysattr) (TupleTableSlot *slot, int attnum, bool *isnull);
+	Datum		(*getsysattr) (TupleTableSlot *slot, int attphysnum, bool *isnull);
 
 	/*
 	 * Make the contents of the slot solely depend on the slot, and not on
@@ -328,7 +328,7 @@ extern MinimalTuple ExecFetchSlotMinimalTuple(TupleTableSlot *slot,
 extern Datum ExecFetchSlotHeapTupleDatum(TupleTableSlot *slot);
 extern void slot_getmissingattrs(TupleTableSlot *slot, int startAttNum,
 								 int lastAttNum);
-extern void slot_getsomeattrs_int(TupleTableSlot *slot, int attnum);
+extern void slot_getsomeattrs_int(TupleTableSlot *slot, int attphysnum);
 
 
 #ifndef FRONTEND
@@ -338,10 +338,10 @@ extern void slot_getsomeattrs_int(TupleTableSlot *slot, int attnum);
  * valid at least up through the attnum'th entry.
  */
 static inline void
-slot_getsomeattrs(TupleTableSlot *slot, int attnum)
+slot_getsomeattrs(TupleTableSlot *slot, int attphysnum)
 {
-	if (slot->tts_nvalid < attnum)
-		slot_getsomeattrs_int(slot, attnum);
+	if (slot->tts_nvalid < attphysnum)
+		slot_getsomeattrs_int(slot, attphysnum);
 }
 
 /*
@@ -364,31 +364,31 @@ slot_getallattrs(TupleTableSlot *slot)
  * it.
  */
 static inline bool
-slot_attisnull(TupleTableSlot *slot, int attnum)
+slot_attisnull(TupleTableSlot *slot, int attphysnum)
 {
-	AssertArg(attnum > 0);
+	AssertArg(attphysnum > 0);
 
-	if (attnum > slot->tts_nvalid)
-		slot_getsomeattrs(slot, attnum);
+	if (attphysnum > slot->tts_nvalid)
+		slot_getsomeattrs(slot, attphysnum);
 
-	return slot->tts_isnull[attnum - 1];
+	return slot->tts_isnull[attphysnum - 1];
 }
 
 /*
  * slot_getattr - fetch one attribute of the slot's contents.
  */
 static inline Datum
-slot_getattr(TupleTableSlot *slot, int attnum,
+slot_getattr(TupleTableSlot *slot, int attphysnum,
 			 bool *isnull)
 {
-	AssertArg(attnum > 0);
+	AssertArg(attphysnum > 0);
 
-	if (attnum > slot->tts_nvalid)
-		slot_getsomeattrs(slot, attnum);
+	if (attphysnum > slot->tts_nvalid)
+		slot_getsomeattrs(slot, attphysnum);
 
-	*isnull = slot->tts_isnull[attnum - 1];
+	*isnull = slot->tts_isnull[attphysnum - 1];
 
-	return slot->tts_values[attnum - 1];
+	return slot->tts_values[attphysnum - 1];
 }
 
 /*
@@ -399,23 +399,23 @@ slot_getattr(TupleTableSlot *slot, int attnum,
  *  the slot type is the one that supports system attributes.
  */
 static inline Datum
-slot_getsysattr(TupleTableSlot *slot, int attnum, bool *isnull)
+slot_getsysattr(TupleTableSlot *slot, int attphysnum, bool *isnull)
 {
-	AssertArg(attnum < 0);		/* caller error */
+	AssertArg(attphysnum < 0);		/* caller error */
 
-	if (attnum == TableOidAttributeNumber)
+	if (attphysnum == TableOidAttributeNumber)
 	{
 		*isnull = false;
 		return ObjectIdGetDatum(slot->tts_tableOid);
 	}
-	else if (attnum == SelfItemPointerAttributeNumber)
+	else if (attphysnum == SelfItemPointerAttributeNumber)
 	{
 		*isnull = false;
 		return PointerGetDatum(&slot->tts_tid);
 	}
 
 	/* Fetch the system attribute from the underlying tuple. */
-	return slot->tts_ops->getsysattr(slot, attnum, isnull);
+	return slot->tts_ops->getsysattr(slot, attphysnum, isnull);
 }
 
 /*
diff --git a/src/include/foreign/foreign.h b/src/include/foreign/foreign.h
index 75538110fc..0e28214a86 100644
--- a/src/include/foreign/foreign.h
+++ b/src/include/foreign/foreign.h
@@ -76,7 +76,7 @@ extern ForeignDataWrapper *GetForeignDataWrapperByName(const char *name,
 													   bool missing_ok);
 extern ForeignTable *GetForeignTable(Oid relid);
 
-extern List *GetForeignColumnOptions(Oid relid, AttrNumber attnum);
+extern List *GetForeignColumnOptions(Oid relid, AttrNumber attphysnum);
 
 extern Oid	get_foreign_data_wrapper_oid(const char *fdwname, bool missing_ok);
 extern Oid	get_foreign_server_oid(const char *servername, bool missing_ok);
diff --git a/src/include/parser/parsetree.h b/src/include/parser/parsetree.h
index 3a1afffd18..0aa6de3247 100644
--- a/src/include/parser/parsetree.h
+++ b/src/include/parser/parsetree.h
@@ -35,13 +35,13 @@
  * Given an RTE and an attribute number, return the appropriate
  * variable name or alias for that attribute of that RTE.
  */
-extern char *get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attnum);
+extern char *get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attphysnum);
 
 /*
  * Check whether an attribute of an RTE has been dropped
  */
 extern bool get_rte_attribute_is_dropped(RangeTblEntry *rte,
-										 AttrNumber attnum);
+										 AttrNumber attphysnum);
 
 
 /* ----------------
diff --git a/src/include/utils/acl.h b/src/include/utils/acl.h
index 48f7d72add..a51586f473 100644
--- a/src/include/utils/acl.h
+++ b/src/include/utils/acl.h
@@ -234,9 +234,9 @@ extern void ExecAlterDefaultPrivilegesStmt(ParseState *pstate, AlterDefaultPrivi
 
 extern void RemoveRoleFromObjectACL(Oid roleid, Oid classid, Oid objid);
 
-extern AclMode pg_attribute_aclmask(Oid table_oid, AttrNumber attnum,
+extern AclMode pg_attribute_aclmask(Oid table_oid, AttrNumber attphysnum,
 									Oid roleid, AclMode mask, AclMaskHow how);
-extern AclMode pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum,
+extern AclMode pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attphysnum,
 										Oid roleid, AclMode mask,
 										AclMaskHow how, bool *is_missing);
 extern AclMode pg_class_aclmask(Oid table_oid, Oid roleid,
@@ -267,9 +267,9 @@ extern AclMode pg_foreign_server_aclmask(Oid srv_oid, Oid roleid,
 extern AclMode pg_type_aclmask(Oid type_oid, Oid roleid,
 							   AclMode mask, AclMaskHow how);
 
-extern AclResult pg_attribute_aclcheck(Oid table_oid, AttrNumber attnum,
+extern AclResult pg_attribute_aclcheck(Oid table_oid, AttrNumber attphysnum,
 									   Oid roleid, AclMode mode);
-extern AclResult pg_attribute_aclcheck_ext(Oid table_oid, AttrNumber attnum,
+extern AclResult pg_attribute_aclcheck_ext(Oid table_oid, AttrNumber attphysnum,
 										   Oid roleid, AclMode mode,
 										   bool *is_missing);
 extern AclResult pg_attribute_aclcheck_all(Oid table_oid, Oid roleid,
diff --git a/src/include/utils/attoptcache.h b/src/include/utils/attoptcache.h
index ee37af9500..1042d41503 100644
--- a/src/include/utils/attoptcache.h
+++ b/src/include/utils/attoptcache.h
@@ -23,6 +23,6 @@ typedef struct AttributeOpts
 	float8		n_distinct_inherited;
 } AttributeOpts;
 
-extern AttributeOpts *get_attribute_options(Oid spcid, int attnum);
+extern AttributeOpts *get_attribute_options(Oid spcid, int attphysnum);
 
 #endif							/* ATTOPTCACHE_H */
diff --git a/src/include/utils/lsyscache.h b/src/include/utils/lsyscache.h
index b8dd27d4a9..3f90894219 100644
--- a/src/include/utils/lsyscache.h
+++ b/src/include/utils/lsyscache.h
@@ -62,7 +62,7 @@ typedef struct AttStatsSlot
 } AttStatsSlot;
 
 /* Hook for plugins to get control in get_attavgwidth() */
-typedef int32 (*get_attavgwidth_hook_type) (Oid relid, AttrNumber attnum);
+typedef int32 (*get_attavgwidth_hook_type) (Oid relid, AttrNumber attphysnum);
 extern PGDLLIMPORT get_attavgwidth_hook_type get_attavgwidth_hook;
 
 extern bool op_in_opfamily(Oid opno, Oid opfamily);
@@ -88,14 +88,14 @@ extern bool equality_ops_are_compatible(Oid opno1, Oid opno2);
 extern bool comparison_ops_are_compatible(Oid opno1, Oid opno2);
 extern Oid	get_opfamily_proc(Oid opfamily, Oid lefttype, Oid righttype,
 							  int16 procnum);
-extern char *get_attname(Oid relid, AttrNumber attnum, bool missing_ok);
-extern AttrNumber get_attnum(Oid relid, const char *attname);
-extern int	get_attstattarget(Oid relid, AttrNumber attnum);
-extern char get_attgenerated(Oid relid, AttrNumber attnum);
-extern Oid	get_atttype(Oid relid, AttrNumber attnum);
-extern void get_atttypetypmodcoll(Oid relid, AttrNumber attnum,
+extern char *get_attname(Oid relid, AttrNumber attphysnum, bool missing_ok);
+extern AttrNumber get_attphysnum(Oid relid, const char *attname);
+extern int	get_attstattarget(Oid relid, AttrNumber attphysnum);
+extern char get_attgenerated(Oid relid, AttrNumber attphysnum);
+extern Oid	get_atttype(Oid relid, AttrNumber attphysnum);
+extern void get_atttypetypmodcoll(Oid relid, AttrNumber attphysnum,
 								  Oid *typid, int32 *typmod, Oid *collid);
-extern Datum get_attoptions(Oid relid, int16 attnum);
+extern Datum get_attoptions(Oid relid, int16 attphysnum);
 extern Oid	get_cast_oid(Oid sourcetypeid, Oid targettypeid, bool missing_ok);
 extern char *get_collation_name(Oid colloid);
 extern bool get_collation_isdeterministic(Oid colloid);
@@ -184,7 +184,7 @@ extern const struct SubscriptRoutines *getSubscriptingRoutines(Oid typid,
 extern Oid	getBaseType(Oid typid);
 extern Oid	getBaseTypeAndTypmod(Oid typid, int32 *typmod);
 extern int32 get_typavgwidth(Oid typid, int32 typmod);
-extern int32 get_attavgwidth(Oid relid, AttrNumber attnum);
+extern int32 get_attavgwidth(Oid relid, AttrNumber attphysnum);
 extern bool get_attstatsslot(AttStatsSlot *sslot, HeapTuple statstuple,
 							 int reqkind, Oid reqop, int flags);
 extern void free_attstatsslot(AttStatsSlot *sslot);
diff --git a/src/include/utils/relcache.h b/src/include/utils/relcache.h
index c93d8654bb..4733e06849 100644
--- a/src/include/utils/relcache.h
+++ b/src/include/utils/relcache.h
@@ -84,7 +84,7 @@ extern void RelationInitTableAccessMethod(Relation relation);
  * Routines to support ereport() reports of relation-related errors
  */
 extern int	errtable(Relation rel);
-extern int	errtablecol(Relation rel, int attnum);
+extern int	errtablecol(Relation rel, int attphysnum);
 extern int	errtablecolname(Relation rel, const char *colname);
 extern int	errtableconstraint(Relation rel, const char *conname);
 
diff --git a/src/include/utils/selfuncs.h b/src/include/utils/selfuncs.h
index d485b9bfcd..e7afaa14fc 100644
--- a/src/include/utils/selfuncs.h
+++ b/src/include/utils/selfuncs.h
@@ -136,7 +136,7 @@ typedef struct
 /* Hooks for plugins to get control when we ask for stats */
 typedef bool (*get_relation_stats_hook_type) (PlannerInfo *root,
 											  RangeTblEntry *rte,
-											  AttrNumber attnum,
+											  AttrNumber attphysnum,
 											  VariableStatData *vardata);
 extern PGDLLIMPORT get_relation_stats_hook_type get_relation_stats_hook;
 typedef bool (*get_index_stats_hook_type) (PlannerInfo *root,
diff --git a/src/include/utils/syscache.h b/src/include/utils/syscache.h
index 4463ea66be..a7c817a72f 100644
--- a/src/include/utils/syscache.h
+++ b/src/include/utils/syscache.h
@@ -38,7 +38,7 @@ enum SysCacheIdentifier
 	AMOPSTRATEGY,
 	AMPROCNUM,
 	ATTNAME,
-	ATTNUM,
+	ATTPHYSNUM,
 	AUTHMEMMEMROLE,
 	AUTHMEMROLEMEM,
 	AUTHNAME,
@@ -151,8 +151,8 @@ extern HeapTuple SearchSysCacheAttName(Oid relid, const char *attname);
 extern HeapTuple SearchSysCacheCopyAttName(Oid relid, const char *attname);
 extern bool SearchSysCacheExistsAttName(Oid relid, const char *attname);
 
-extern HeapTuple SearchSysCacheAttNum(Oid relid, int16 attnum);
-extern HeapTuple SearchSysCacheCopyAttNum(Oid relid, int16 attnum);
+extern HeapTuple SearchSysCacheAttNum(Oid relid, int16 attphysnum);
+extern HeapTuple SearchSysCacheCopyAttNum(Oid relid, int16 attphysnum);
 
 extern Datum SysCacheGetAttr(int cacheId, HeapTuple tup,
 							 AttrNumber attributeNumber, bool *isNull);
diff --git a/src/pl/plpgsql/src/plpgsql.h b/src/pl/plpgsql/src/plpgsql.h
index 4e6ee1c619..1a09017356 100644
--- a/src/pl/plpgsql/src/plpgsql.h
+++ b/src/pl/plpgsql/src/plpgsql.h
@@ -426,7 +426,7 @@ typedef struct PLpgSQL_recfield
 	int			recparentno;	/* dno of parent record */
 	int			nextfield;		/* dno of next child, or -1 if none */
 	uint64		rectupledescid; /* record's tupledesc ID as of last lookup */
-	ExpandedRecordFieldInfo finfo;	/* field's attnum and type info */
+	ExpandedRecordFieldInfo finfo;	/* field's attphysnum and type info */
 	/* if rectupledescid == INVALID_TUPLEDESC_IDENTIFIER, finfo isn't valid */
 } PLpgSQL_recfield;
 
diff --git a/src/test/modules/test_misc/t/001_constraint_validation.pl b/src/test/modules/test_misc/t/001_constraint_validation.pl
index 3b9fc66b8e..62ef05dd08 100644
--- a/src/test/modules/test_misc/t/001_constraint_validation.pl
+++ b/src/test/modules/test_misc/t/001_constraint_validation.pl
@@ -209,7 +209,7 @@ run_sql_command(
 	c int,
 	d int,
 	e int,
-	LIKE list_parted2,  -- a will have attnum = 4
+	LIKE list_parted2,  -- a will have attphysnum = 4
 	CONSTRAINT check_b CHECK (b IS NULL OR b = \'a\'),
 	CONSTRAINT check_a CHECK (a IS NOT NULL AND a = 7)
 	);
diff --git a/src/test/regress/regress.c b/src/test/regress/regress.c
index ba3532a51e..f34c8474b4 100644
--- a/src/test/regress/regress.c
+++ b/src/test/regress/regress.c
@@ -272,7 +272,7 @@ ttdummy(PG_FUNCTION_ARGS)
 	TriggerData *trigdata = (TriggerData *) fcinfo->context;
 	Trigger    *trigger;		/* to get trigger name */
 	char	  **args;			/* arguments */
-	int			attnum[2];		/* fnumbers of start/stop columns */
+	int			attphysnum[2];		/* fnumbers of start/stop columns */
 	Datum		oldon,
 				oldoff;
 	Datum		newon,
@@ -325,29 +325,29 @@ ttdummy(PG_FUNCTION_ARGS)
 
 	for (i = 0; i < 2; i++)
 	{
-		attnum[i] = SPI_fnumber(tupdesc, args[i]);
-		if (attnum[i] <= 0)
+		attphysnum[i] = SPI_fnumber(tupdesc, args[i]);
+		if (attphysnum[i] <= 0)
 			elog(ERROR, "ttdummy (%s): there is no attribute %s",
 				 relname, args[i]);
-		if (SPI_gettypeid(tupdesc, attnum[i]) != INT4OID)
+		if (SPI_gettypeid(tupdesc, attphysnum[i]) != INT4OID)
 			elog(ERROR, "ttdummy (%s): attribute %s must be of integer type",
 				 relname, args[i]);
 	}
 
-	oldon = SPI_getbinval(trigtuple, tupdesc, attnum[0], &isnull);
+	oldon = SPI_getbinval(trigtuple, tupdesc, attphysnum[0], &isnull);
 	if (isnull)
 		elog(ERROR, "ttdummy (%s): %s must be NOT NULL", relname, args[0]);
 
-	oldoff = SPI_getbinval(trigtuple, tupdesc, attnum[1], &isnull);
+	oldoff = SPI_getbinval(trigtuple, tupdesc, attphysnum[1], &isnull);
 	if (isnull)
 		elog(ERROR, "ttdummy (%s): %s must be NOT NULL", relname, args[1]);
 
 	if (newtuple != NULL)		/* UPDATE */
 	{
-		newon = SPI_getbinval(newtuple, tupdesc, attnum[0], &isnull);
+		newon = SPI_getbinval(newtuple, tupdesc, attphysnum[0], &isnull);
 		if (isnull)
 			elog(ERROR, "ttdummy (%s): %s must be NOT NULL", relname, args[0]);
-		newoff = SPI_getbinval(newtuple, tupdesc, attnum[1], &isnull);
+		newoff = SPI_getbinval(newtuple, tupdesc, attphysnum[1], &isnull);
 		if (isnull)
 			elog(ERROR, "ttdummy (%s): %s must be NOT NULL", relname, args[1]);
 
@@ -390,16 +390,16 @@ ttdummy(PG_FUNCTION_ARGS)
 	/* change date column(s) */
 	if (newtuple)				/* UPDATE */
 	{
-		cvals[attnum[0] - 1] = newoff;	/* start_date eq current date */
-		cnulls[attnum[0] - 1] = ' ';
-		cvals[attnum[1] - 1] = TTDUMMY_INFINITY;	/* stop_date eq INFINITY */
-		cnulls[attnum[1] - 1] = ' ';
+		cvals[attphysnum[0] - 1] = newoff;	/* start_date eq current date */
+		cnulls[attphysnum[0] - 1] = ' ';
+		cvals[attphysnum[1] - 1] = TTDUMMY_INFINITY;	/* stop_date eq INFINITY */
+		cnulls[attphysnum[1] - 1] = ' ';
 	}
 	else
 		/* DELETE */
 	{
-		cvals[attnum[1] - 1] = newoff;	/* stop_date eq current date */
-		cnulls[attnum[1] - 1] = ' ';
+		cvals[attphysnum[1] - 1] = newoff;	/* stop_date eq current date */
+		cnulls[attphysnum[1] - 1] = ' ';
 	}
 
 	/* if there is no plan ... */
@@ -442,7 +442,7 @@ ttdummy(PG_FUNCTION_ARGS)
 
 	/* Tuple to return to upper Executor ... */
 	if (newtuple)				/* UPDATE */
-		rettuple = SPI_modifytuple(rel, trigtuple, 1, &(attnum[1]), &newoff, NULL);
+		rettuple = SPI_modifytuple(rel, trigtuple, 1, &(attphysnum[1]), &newoff, NULL);
 	else						/* DELETE */
 		rettuple = trigtuple;
 
diff --git a/src/test/regress/sql/alter_table.sql b/src/test/regress/sql/alter_table.sql
index 52001e3135..6784da0f4c 100644
--- a/src/test/regress/sql/alter_table.sql
+++ b/src/test/regress/sql/alter_table.sql
@@ -1250,8 +1250,8 @@ create table gc1() inherits (c1);
 
 select relname, attname, attinhcount, attislocal
 from pg_class join pg_attribute on (pg_class.oid = pg_attribute.attrelid)
-where relname in ('p1','p2','c1','gc1') and attnum > 0 and not attisdropped
-order by relname, attnum;
+where relname in ('p1','p2','c1','gc1') and attphysnum > 0 and not attisdropped
+order by relname, attphysnum;
 
 -- should work
 alter table only p1 drop column name;
@@ -1273,8 +1273,8 @@ alter table dropColumnExists drop column if exists non_existing; --succeed
 
 select relname, attname, attinhcount, attislocal
 from pg_class join pg_attribute on (pg_class.oid = pg_attribute.attrelid)
-where relname in ('p1','p2','c1','gc1') and attnum > 0 and not attisdropped
-order by relname, attnum;
+where relname in ('p1','p2','c1','gc1') and attphysnum > 0 and not attisdropped
+order by relname, attphysnum;
 
 drop table p1, p2 cascade;
 
@@ -1287,8 +1287,8 @@ alter table depth0 add c text;
 
 select attrelid::regclass, attname, attinhcount, attislocal
 from pg_attribute
-where attnum > 0 and attrelid::regclass in ('depth0', 'depth1', 'depth2')
-order by attrelid::regclass::text, attnum;
+where attphysnum > 0 and attrelid::regclass in ('depth0', 'depth1', 'depth2')
+order by attrelid::regclass::text, attphysnum;
 
 -- test renumbering of child-table columns in inherited operations
 
@@ -2434,7 +2434,7 @@ CREATE TABLE part_1 (
 );
 ALTER TABLE list_parted ATTACH PARTITION part_1 FOR VALUES IN (1);
 -- attislocal and conislocal are always false for merged attributes and constraints respectively.
-SELECT attislocal, attinhcount FROM pg_attribute WHERE attrelid = 'part_1'::regclass AND attnum > 0;
+SELECT attislocal, attinhcount FROM pg_attribute WHERE attrelid = 'part_1'::regclass AND attphysnum > 0;
 SELECT conislocal, coninhcount FROM pg_constraint WHERE conrelid = 'part_1'::regclass AND conname = 'check_a';
 
 -- check that the new partition won't overlap with an existing partition
@@ -2580,7 +2580,7 @@ CREATE TABLE part_7_a_null (
 	c int,
 	d int,
 	e int,
-	LIKE list_parted2,  -- 'a' will have attnum = 4
+	LIKE list_parted2,  -- 'a' will have attphysnum = 4
 	CONSTRAINT check_b CHECK (b IS NULL OR b = 'a'),
 	CONSTRAINT check_a CHECK (a IS NOT NULL AND a = 7)
 );
@@ -2707,7 +2707,7 @@ DROP TABLE not_a_part;
 -- check that, after being detached, attinhcount/coninhcount is dropped to 0 and
 -- attislocal/conislocal is set to true
 ALTER TABLE list_parted2 DETACH PARTITION part_3_4;
-SELECT attinhcount, attislocal FROM pg_attribute WHERE attrelid = 'part_3_4'::regclass AND attnum > 0;
+SELECT attinhcount, attislocal FROM pg_attribute WHERE attrelid = 'part_3_4'::regclass AND attphysnum > 0;
 SELECT coninhcount, conislocal FROM pg_constraint WHERE conrelid = 'part_3_4'::regclass AND conname = 'check_a';
 DROP TABLE part_3_4;
 
@@ -2816,8 +2816,8 @@ alter table p11 drop a;
 alter table p11 add a int;
 alter table p11 drop a;
 alter table p11 add a int not null;
--- attnum for key attribute 'a' is different in p, p1, and p11
-select attrelid::regclass, attname, attnum
+-- attphysnum for key attribute 'a' is different in p, p1, and p11
+select attrelid::regclass, attname, attphysnum
 from pg_attribute
 where attname = 'a'
  and (attrelid = 'p'::regclass
